# -*- coding: utf-8 -*-
## graphenfenster.py
## © Claus Albowski

## Importe:
import platform
import os
versionsNummer=platform.python_version()[0]
if versionsNummer=='2':
    from Tkinter import *
    import tkFileDialog as fileDialog
else:
    from tkinter import *
    import tkinter.filedialog as fileDialog

from graphenModell import *
from fensterElemente import *
#### Dialoge
from dialoge import * # eigene
#### Spezialfunktionen
from random import randint
from controller import Controller


class GraphenApplication(Frame):
    
    def __init__(self, master=None, zeichenflaechenBreite=600, zeichenflaechenHoehe=600):
        Frame.__init__(self, master)
        self.breite = zeichenflaechenBreite
        self.hoehe = zeichenflaechenHoehe
        self.__cont=Controller.gibController(self)

        top = self.winfo_toplevel()
        ## Menübereich
        self.menuBar = Menu(top)
        top['menu'] = self.menuBar
        #### Datei-Menu
        self.dateiSubMenu = Menu(self.menuBar)
        self.menuBar.add_cascade(label='Datei', font='Sans 10 bold', menu=self.dateiSubMenu)
        self.dateiSubMenu.add_command(label='Daten einlesen', font='Sans 10 bold', command=self.onLesen)
        self.dateiSubMenu.add_command(label='Daten speichern', font='Sans 10 bold', command=self.onSpeichern)
        self.dateiSubMenu.add_command(label='aktuelles Verzeichnis setzen', font='Sans 10 bold', command=self.onVerzeichnis)
        self.dateiSubMenu.add_command(label=u'aktuell: Home-Verzeichnis', font='Sans 10 bold', command=self.onHome)
        self.dateiSubMenu.add_command(label='Beenden', font='Sans 10 bold', command=self.onBeenden)
        #### Graphenentwicklungs-Menu
        self.neuSubMenu = Menu(self.menuBar)
        self.menuBar.add_cascade(label='Neu', font='Sans 10 bold', menu=self.neuSubMenu)
        self.neuSubMenu.add_command(label='Neuer Graph', font='Sans 10 bold', command=self.onNeuerGraph)
        self.neuSubMenu.add_command(label='Knoten', font='Sans 10 bold', command=self.onKnotenNeu)
        self.neuSubMenu.add_command(label='mehrere Knoten', font='Sans 10 bold', command=self.onVieleKnoten)
        self.neuSubMenu.add_command(label='Kante', font='Sans 10 bold', command=self.onKanteNeu)
        self.neuSubMenu.add_command(label='Kante mit Maus', font='Sans 10 bold', command=self.onKanteMaus)
        self.neuSubMenu.add_command(label='Kanten zwischen allen', font='Sans 10 bold', command=self.onAlleKanten)
        #### Bearbeiten-Menu
        self.bearbeitenSubMenu = Menu(self.menuBar)
        self.menuBar.add_cascade(label='Bearbeiten', font='Sans 10 bold', menu=self.bearbeitenSubMenu)
        self.bearbeitenSubMenu.add_command(label='Knoten verschieben', font='Sans 10 bold', command=self.onKnotenVerschieben)
        self.bearbeitenSubMenu.add_command(label='Knoten umbenennen', font='Sans 10 bold', command=self.onKnotenNamen)
        self.bearbeitenSubMenu.add_command(label=u'Knoten färben', font='Sans 10 bold', command=self.onKnotenFaerben)
        self.bearbeitenSubMenu.add_command(label='Kante beschriften', font='Sans 10 bold', command=self.onKanteBeschriften)
        self.bearbeitenSubMenu.add_command(label='alle Kanten beschriften', font='Sans 10 bold', command=self.onAlleBeschriften)
        self.bearbeitenSubMenu.add_command(label=u'Kante färben', font='Sans 10 bold', command=self.onKanteFaerben)
        self.bearbeitenSubMenu.add_command(label=u'Kante im Bogen', font='Sans 10 bold', command=self.onKanteBogen)
        self.bearbeitenSubMenu.add_command(label=u'Richtung der Kante wechseln', font='Sans 10 bold', command=self.onRichtung)
        self.bearbeitenSubMenu.add_command(label=u'Textposition verschieben', font='Sans 10 bold', command=self.onKorrigiereTextPosition)
        #### Loeschen-Menu
        self.loeschenSubMenu = Menu(self.menuBar)
        self.menuBar.add_cascade(label=u'Löschen', font='Sans 10 bold', menu=self.loeschenSubMenu)
        self.loeschenSubMenu.add_command(label=u'Knoten löschen', font='Sans 10 bold', command=self.onLoescheKnoten)
        self.loeschenSubMenu.add_command(label=u'Kante löschen', font='Sans 10 bold', command=self.onLoescheKante)
        #### Darstellungs-Menu
        self.darstellungSubMenu = Menu(self.menuBar)
        self.menuBar.add_cascade(label='Darstellung', font='Sans 10 bold', menu=self.darstellungSubMenu)
        self.darstellungSubMenu.add_command(label='Graphendaten zeigen', font='Sans 10 bold', command=self.onGraphenDatenZeigen)
        self.darstellungSubMenu.add_command(label='Graphendaten in Datei', font='Sans 10 bold', command=self.onGraphenDatenText)
        self.darstellungSubMenu.add_command(label='Bild speichern', font='Sans 10 bold', command=self.onBild)
        #### Hilfe-Menu
        self.hilfeSubMenu = Menu(self.menuBar)
        self.menuBar.add_cascade(label='Hilfe', font='Sans 10 bold', menu=self.hilfeSubMenu)
        self.hilfeSubMenu.add_command(label='Beispiel zeigen', font='Sans 10 bold', command=self.zeichne_Objekte)
        self.hilfeSubMenu.add_command(label='Hilfe zum Entwickeln', font='Sans 10 bold', command=self.zeigeHilfeText1)
        self.hilfeSubMenu.add_command(label='Hilfe zu den Dateien', font='Sans 10 bold', command=self.zeigeHilfeText2)
        self.hilfeSubMenu.add_command(label='Hilfe zur Bilddatei', font='Sans 10 bold', command=self.zeigeHilfeText3)
        self.hilfeSubMenu.add_command(label='Hilfe zu Kurztasten', font='Sans 10 bold', command=self.zeigeHilfeText4)
        self.hilfeSubMenu.add_command(label='Hilfe zu Mausaktionen', font='Sans 10 bold', command=self.zeigeHilfeText5)
        self.hilfeSubMenu.add_command(label=u'Hilfe zum Ändern der Fenstergröße', font='Sans 10 bold', command=self.zeigeHilfeText6)

        ## Anlegen der Attribute        
        self.__g=Graph.gibGraphen()
        self.__g.SetzeView=self
        self.__click_position = (100,100)
        self.__click_ID = None     # fuer linken Mausklick
        self.__neueKante = False # fuer grafische Verknuepfung
        self.__ausgewaehlt = None  # fuer Ziehen mit linker Maustaste gedrueckt
        self.__release_IDs = None   # fuer linke Maustaste loslassen
        ## Tk-Variable [Daten für Widgets]
        self.__graphenVariable = StringVar()
        self.__graphenVariable.set('')
        self.__geaendert = False
        self.__HilfeMausAnzeigen = True
        self.__aktuellesVerzeichnis = '.'

        ## Definition von Kurztasten fuer das Fenster
        self.winfo_toplevel().bind("<Control-o>", self.onControl_o)
        self.winfo_toplevel().bind("<Control-s>", self.onControl_s)
        self.winfo_toplevel().bind("<Control-p>", self.onControl_p)
        self.winfo_toplevel().bind("<Alt-n>", self.onAlt_n)
        self.winfo_toplevel().bind("<Control-k>", self.onControl_k)
        self.winfo_toplevel().bind("<Alt-k>", self.onAlt_k)
        self.winfo_toplevel().bind("<Control-b>", self.onControl_b)
        self.winfo_toplevel().bind("<Control-f>", self.onControl_f)
        self.winfo_toplevel().bind("<Alt-f>", self.onAlt_f)
        self.winfo_toplevel().bind("<Alt-a>", self.onAlt_a)
        self.winfo_toplevel().bind("<Alt-b>", self.onAlt_b)
        self.winfo_toplevel().bind("<Alt-m>", self.onAlt_m)
        self.winfo_toplevel().bind("<Control-t>", self.onControl_t)

        ## Oberflaeche erzeugen
        self.createWidgets()
        self.pack()
    def onControl_o(self,evt): self.onLesen()
    def onControl_s(self,evt): self.onSpeichern()
    def onControl_p(self,evt): self.onBild()
    def onAlt_n(self,evt): self.onNeuerGraph()
    def onControl_k(self,evt): self.onKnotenNeu()
    def onAlt_k(self,evt): self.onKanteNeu()
    def onControl_b(self,evt): self.onKanteBogen()
    def onControl_f(self,evt): self.onKnotenFaerben()
    def onAlt_f(self,evt): self.onKanteFaerben()
    def onAlt_a(self,evt): self.onAlleBeschriften()
    def onAlt_b(self,evt): self.onKanteBeschriften()
    def onAlt_m(self,evt): self.onKanteMaus()
    def onControl_t(self,evt): self.onKorrigiereTextPosition()
    

    def createWidgets(self):
        '''Einsatz des grid - Geometriemanagers'''
        # 1. Zeile
        self.graphen_Label = Label(self, font='Sans 12', text=" Name des Graphen: ")
        self.graphen_Label.grid(row=0,column=0)
        self.graphenNameLabel = Label(self, textvariable=self.__graphenVariable,
                                      width=30, font='Sans 12 bold italic', bg='white', fg='black')
        self.graphenNameLabel.grid(row=0,column=1)
        self.beenden_Button = Button(self, text="Beenden", font='Sans 10 bold', command=self.onBeenden)
        self.beenden_Button.grid(row=0,column=2)
        # 2. Zeile
        self.graphenFrame=Frame(self)
        self.graphenFrame.grid(row=1,column=0, columnspan=3)
        self.zeichenflaeche = Canvas(self.graphenFrame,
                                     width=self.breite,
                                     height=self.hoehe,
                                     bg='white',
                                     scrollregion=(0, 0, 1800, 1200))
        zf=self.zeichenflaeche # lokale Hilfsvariable
        zf.grid(row=0,column=0)
        scrollX=Scrollbar(self.graphenFrame,orient=HORIZONTAL,command=zf.xview)
        scrollY=Scrollbar(self.graphenFrame,orient=VERTICAL,command=zf.yview)
        scrollX.grid(row=1,column=0, sticky=W+E)
        scrollY.grid(row=0,column=1, sticky=N+S)
        zf['xscrollcommand'] = scrollX.set
        zf['yscrollcommand'] = scrollY.set

        # Binden von Ereignissen an die Zeichenflaeche:
        zf.bind("<Button-1>", self.links_Mausklick)
        zf.bind("<Double-Button-1>", self.links_Doppelklick)
        zf.bind("<Button-3>", self.rechts_Mausklick)
        zf.bind("<ButtonRelease>", self.links_loslassen)
        zf.bind("<Motion>", self.bewegt)


    #### --------- Dateimenue ------------------------------
    def onLesen(self):
        '''Der Name des Graphen wird zwingend aus dem Dateinamen entnommen.'''
        if not self.__cont.istLeer():
            dialog=BestaetigungsDialog(self, u'Aktuellen Graphen löschen?', 'Wollen Sie das wirklich?')
            if dialog.result==None: return
            if dialog.result==False: return
            if dialog.result==True:
                self.__g.loescheGraphenDefinition()
                self.__cont.loescheAlle(self.zeichenflaeche)
                self.__graphenVariable.set('')
        verzeichnis = 'GraphenDaten'
        if self.__aktuellesVerzeichnis!='.': verzeichnis = self.__aktuellesVerzeichnis
        dateiname=fileDialog.askopenfilename(parent=self,
                                                     defaultextension='graph',
                                                     initialdir=verzeichnis,
                                                     title="Graphendaten laden")
        if (dateiname=='') or(dateiname==None) or dateiname==():
            MeldungDialog(self,'Info', 'Keine Daten gelesen!')
            return
        else:
            #Graphenwechsel verhindern
            graphenName=self.__g.graphenNameAusDateiNamen(dateiname)
            if not(self.setzeGraphenNamen(graphenName)): return
            daten=self.__g.lies(dateiname, datenAnApp=True)
            if daten==None:
                MeldungDialog(self,'Warnung','Keine Daten gelesen!')
                return
            self.__cont.erzeugeGraphenAusDaten(self.zeichenflaeche,daten)
            self.__geaendert = False
        
    def onSpeichern(self):
        '''Es wird zunaechst geprueft, ob ein Graphenname existiert.'''
        if self.__graphenVariable.get()=='':
            self.setzeGraphenNamen()
        verzeichnis = 'GraphenDaten'
        if self.__aktuellesVerzeichnis!='.': verzeichnis = self.__aktuellesVerzeichnis
        dateiname=self.__graphenVariable.get()+'.graph'
        dateiname=fileDialog.asksaveasfilename(parent=self,
                                                       initialfile=dateiname,
                                                       defaultextension='wirkdia',
                                                       initialdir=verzeichnis,
                                                       title="Graphendaten speichern")
        if (dateiname=='') or(dateiname==None) or dateiname==():
            self.__g.sichereDaten()
            MeldungDialog(self,'Info', 'Keine Daten geschrieben!')
        else:
            daten=self.__cont.gibDatenMit(self.zeichenflaeche)
            self.__g.speichere(dateiname,daten)
            self.__geaendert = False
        
    def setzeGraphenNamen(self, graphenName=''):
        if graphenName=='': # aus dem Menue aufgerufen
            dialog=EingabeDialog(self, u'Namen des Graphen wählen', 'Namen eingeben')
            if dialog.result==None: return # cancel ausgewaehlt
            graphenName=dialog.result
        if self.__graphenVariable.get()!='':
            if self.__graphenVariable.get()!=graphenName:
                MeldungDialog(self,'Warnung','Zum Graphenwechsel \n das Programm \n neu starten!')
                return False
        self.__graphenVariable.set(graphenName)
        return True

    def onHome(self):
        self.__aktuellesVerzeichnis = os.environ["HOME"]
        os.chdir(self.__aktuellesVerzeichnis)

    def onVerzeichnis(self):
        verzeichnisName=self.__aktuellesVerzeichnis
        if verzeichnisName=='.': verzeichnisName=''
        dialog=EingabeDialog(self, u'aktuelles Verzeichnis neu wählen', 'Namen eingeben',verzeichnisName)
        if (dateiname=='') or(dateiname==None) or dateiname==():
            self.__g.sichereDaten()
            verzeichnisName=dialog.result
            try:
                os.chdir(verzeichnisName)
            except OSError as e:
                MeldungDialog(self,'Fehler','Verzeichnis existiert nicht!')
                return
            self.__aktuellesVerzeichnis = verzeichnisName

    def onBeenden(self):
        if self.__geaendert:
            dialog=BestaetigungsDialog(self, 'Achtung!', 'Aktuellen Graphen sichern?')
            if dialog.result=='': return
            if dialog.result==None: return
            if dialog.result==True:
                self.onSpeichern()
                return
        self.quit()
        
    #### ---------- Graphentwicklungs-Menue -------------------------------------    
    def onNeuerGraph(self):
        '''Strategie:
        - noch kein Name und kein Graph: -> Namen festlegen
        - vorhandenes Graphen mit neuem Namen: -> Abfrage, ob gewollt'''
        if self.__cont.istLeer():
            self.setzeGraphenNamen()
            return
        dialog=BestaetigungsDialog(self, u'Aktuellen Graphen löschen?', 'Wollen Sie das wirklich?')
        if dialog.result=='' or dialog.result==None or dialog.result==():
            MeldungDialog(self,'Ergebnis :','abgebrochen')
            return
        if dialog.result==True:
            self.__g.loescheGraphen()
            self.__cont.LoescheAlle(self.zeichenflaeche)
            self.__graphenVariable.set('')
        dialog=EingabeDialog(self, u'Neuer Name für den Graphen', 'Namen eingeben')
        name=dialog.result
        if dialog.result=='' or dialog.result==None or dialog.result==():
            return # cancel ausgewaehlt
        self.__graphenVariable.set(name)
        self.__geaendert = True
    
    def waehle(self, zulaessige=[]): # Knoten oder Kanten
        '''Hilfsmethode zur Auswahl eines zulaessigen Knoten- oder Kantennamen'''
        dialog=AuswahlDialog(self,u'wählen',zulaessige,True)
        if dialog.result=='' or dialog.result==None or dialog.result==():
            return None # bei cancel None
        return dialog.result
    
    def onKnotenNeu(self, pos=(100,100)):
        dialog=N_EingabenDialog(self, 'neuer Knoten', 
                             ['Name','x-Koordinate','y-Koordinate'],
                             ['','100','100'])
        daten=dialog.result
        if dialog.result==None: return # cancel ausgewaehlt
        if dialog.result=='': return # keine Eingabe
        self.__cont.neuerKnoten(self.zeichenflaeche, daten[0],
                                (int(round(float(daten[1]))),int(round(float(daten[2])))))

    def onVieleKnoten(self, n=10):
        dialog=EingabeDialog(self, 'Mehrere Knoten (<=26) gleichzeitig erzeugen', 'Anzahl eingeben',str(n))
        if dialog.result==None: return # cancel ausgewaehlt
        if dialog.result=='': return # keine Eingabe
        try:
            n=int(dialog.result)
        except ValueError as e:
            return
        if n<1: n=1
        if n>26: n= 26
        for i in range(n):
            self.__cont.neuerKnoten(self.zeichenflaeche, chr(65+i), (30+20*i, 30+20*i))
            
    def onKanteNeu(self):
        von=self.waehle(self.__g.gibAlleKnotenNamen())
        if von==None: return
        ziele=[]+self.__g.gibAlleKnotenNamen() # echte Kopie
        if  von in ziele: ziele.remove(von) # Keine Kante zu sich selbst
        auf=self.waehle(ziele)
        if auf==None: return # bei cancel None
        self.__cont.neueKante(self.zeichenflaeche, von, auf)
        self.__geaendert = True

    def onKanteMaus(self):
        '''Zustand wird durch self.__neueKante gesetzt'''
        if self.__HilfeMausAnzeigen:
            dialog=MeldungDialog(self,'Kante mit Maus',
                                 'ersten Knoten anklicken,\n'
                                 +'Maus zum zweiten Knoten ziehen;\n'
                                 +'jeweils linke obere Ecke!')
        self.__HilfeMausAnzeigen = False
        self.__neueKante = True
        
    def onAlleKanten(self):
        '''verbindet alle Knoten mit Kanten
        vorhandene Kanten werden nicht erneut erzeugt'''
        self.__cont.AlleKantenNeu(self.zeichenflaeche,self.__g.gibAlleKnotenNamen())
        

    #### ----------- Bearbeiten-Menu ----------------------------------------
    def onKnotenVerschieben(self, alterName=None):
        '''neue Koordinaten eingeben'''
        knotenName=self.waehle(self.__g.gibAlleKnotenNamen())
        if knotenName==None: return
        name,altX,altY=self.__g.gibKnotenZuNamen(knotenName).gibDaten()
        dialog=N_EingabenDialog(self,
                                'neue Koordinaten:',
                                ['x-Koordinate','y-Koordinate'],
                                [str(int(round(altX))),str(int(round(altY)))])
        daten=dialog.result
        if daten==None: return # cancel ausgewaehlt
        if daten=='': return # keine Eingabe
        try:
            x,y=int(round(float(daten[0]))),int(round(float(daten[1])))
            self.__cont.verschiebeKnotenUm(self.zeichenflaeche,
                                           knotenName,x-altX,y-altY)
        except ValueError as e:
            MeldungDialog(self,'Eingabefehler', 'Zahlen eingeben!')

    def onKnotenNamen(self, alterName=None):
        '''moeglich: Aendern des Namens'''
        if alterName==None:
            alterName=self.knotenWaehlenDialog()
            if alterName==None:
                return # cancel an geklickt
        dialog=EingabeDialog(self,u'Ändere den Namen des Knoten','bisher: '+alterName)
        neuerName=dialog.result
        if neuerName==None: return # cancel an geklickt
        if not(self.__g.pruefeNamen(neuerName)):
            self.Meldung('Name unzulaessig')
            return
        if alterName!=neuerName: # sollte wegen der Pruefung ok sein
            self.__g.aendereKnotenNamen(alterName,neuerName)
            self.__cont.aendereKnotenNamen(self.zeichenflaeche,alterName,neuerName)
            ##self.__cont.aendereKantenZu(self.zeichenflaeche,alterName,neuerName)
            ## geschieht in der Controllermethode aendereKnotenNamen
            self.__geaendert = True
            
    def onKnotenFaerben(self, knotenName=None):
        '''aendert die Fuellfarbe des Knotens'''
        if knotenName==None:
            knotenName=self.waehle(self.__g.gibAlleKnotenNamen())
            if knotenName==None: return
        farbnamen=('red','green','blue','yellow','cyan','brown', 'light gray', 'transparent')
        dialog=AuswahlDialog(self,u'Farbe wählen',farbnamen,True)
        farbe=dialog.result
        if farbe==None: return None # bei cancel None
        if farbe=='transparent': farbe=''
        self.__cont.setzeFarbe(self.zeichenflaeche, knotenName, farbe)
        self.__geaendert = True
    
    def onKanteFaerben(self):
        '''aendert die Farbe der Kante'''
        kantenName=self.waehle(self.__g.gibAlleKantenNamen())
        if kantenName==None: return
        farbnamen=('red','green','blue','magenta','cyan','brown','black','gray', 'light gray')
        dialog=AuswahlDialog(self,u'Farbe wählen',farbnamen,True)
        farbe=dialog.result
        if farbe==None: return None # bei cancel None
        self.__cont.setzeFarbe(self.zeichenflaeche, kantenName, farbe)
        self.__geaendert = True
    
    def onKanteBeschriften(self, name=None):
        '''es wird zunaechst die Art der Beschriftung gewaehlt und
        dann ggf der Inhalt'''
        if name==None: name=self.waehle(self.__g.gibAlleKantenNamen())
        if name==None: return
        typen=('keine', 'Name aus Knoten', 'Abstand', 'extern vorgegeben')
        dialog=AuswahlDialog(self,u'Typ der Beschriftung wählen',typen,True)
        typ=dialog.result
        if typ==None: return None # bei cancel None
        if typ=='keine': self.__cont.neueKantenBeschriftung(self.zeichenflaeche, name, ' ')
        elif typ=='Name aus Knoten': self.__cont.neueKantenBeschriftung(self.zeichenflaeche, name, 'Name')
        elif typ=='Abstand': self.__cont.neueKantenBeschriftung(self.zeichenflaeche, name, 'Abstand')
        else:
            dialog=EingabeDialog(self,'Inhalt eingeben','Beschriftung:')
            neuerInhalt=dialog.result
            if neuerInhalt==None: return
            self.__cont.neueKantenBeschriftung(self.zeichenflaeche, name, 'extern', neuerInhalt)
        self.__geaendert = True

    def onAlleBeschriften(self):
        typen=('keine', 'Name aus Knoten', 'Abstand')
        dialog=AuswahlDialog(self,u'Typ der Beschriftung wählen',typen,True)
        typ=dialog.result
        if typ==None: return None # bei cancel None
        for name in self.__g.gibAlleKantenNamen():
            if typ=='keine': self.__cont.neueKantenBeschriftung(self.zeichenflaeche, name, ' ')
            elif typ=='Name aus Knoten': self.__cont.neueKantenBeschriftung(self.zeichenflaeche, name, 'Name')
            elif typ=='Abstand': self.__cont.neueKantenBeschriftung(self.zeichenflaeche, name, 'Abstand')            
        self.__geaendert = True

    def onKanteBogen(self):
        '''konfiguriert den Versatz, um den der Bogen vom Mittelpunkt abweicht'''
        name=self.waehle(self.__g.gibAlleKantenNamen())
        if name==None: return
        dialog=EingabeDialog(self,'Bogen vom Mittelpunkt versetzen','Faktor ca -1.0 bis 1.0')
        versatzString=dialog.result
        if versatzString==None: return # cancel an geklickt
        try:
            versatz=float(versatzString)
        except ValueError as e:
            versatz=0.0
        self.__cont.aendereVersatz(self.zeichenflaeche,name,versatz)
        self.__geaendert = True

    def onRichtung(self):
        '''tauscht die Richtung einer Kante durch'''
        name=self.waehle(self.__g.gibAlleKantenNamen())
        if name==None: return
        self.__cont.aendereRichtung(self.zeichenflaeche,name)
        self.__geaendert = True

    def onKorrigiereTextPosition(self):
        kantenName=self.waehle(self.__g.gibAlleKantenNamen())
        if kantenName==None: return
        name,ka,ke=self.__cont.gibKanteUndElement(kantenName)
        dx,dy=ke.gibVerschiebungPositionText()
        dialog=N_EingabenDialog(self,
                                'Verschiebung gegenüber Originalposition',
                                ['in x-Richtung >','in y-Richtung v'],
                                [dx,dy])
        ergebnis=dialog.result
        if ergebnis==None: return # cancel an geklickt
        try:
            dx,dy=int(ergebnis[0]),int(ergebnis[1])
        except ValueError as e:
            return
        self.__cont.korrigiereTextPosition(self.zeichenflaeche,kantenName,dx,dy)
        
        
    #### ----------- Loeschen-Menu ----------------------------------------
    def onLoescheKnoten(self):
        dialog=AuswahlDialog(self,
                                'Faktor wählen',
                                self.__g.gibAlleKnotenNamen(),
                                True)
        if dialog.result==None: return # bei cancel None
        name=dialog.result
        self.__cont.loescheKnotenUndKanten(self.zeichenflaeche,name)
        self.__geaendert = True
        
    def onLoescheKante(self):
        name=self.waehle(self.__g.gibAlleKantenNamen())
        if name==None: return
        self.__cont.loescheKante(self.zeichenflaeche, name)
        self.__geaendert = True
    
    #### ---------- Darstellungs-Menue -------------------------------------
    def onGraphenDatenZeigen(self):
        self.__g.sichereDaten()
        zeilen=self.__g.gibDaten()
        dialog=TextAusgabeDialog(self,
                                 'Graphendaten',
                                 self.__graphenVariable.get(),
                                 zeilen)
        
    def onGraphenDatenText(self):
        verzeichnis = 'DatenText'
        dateiname="Daten_"+self.__graphenVariable.get()+".txt"
        dateiname=fileDialog.asksaveasfilename(parent=self,
                                                       initialfile=dateiname,
                                                       defaultextension='txt',
                                                       initialdir=verzeichnis,
                                                       title="Graphendaten als Text speichern")
        if dateiname=='' or dateiname==None or dateiname==():
            MeldungDialog(self,'Info', 'Keine Daten geschrieben!')
            return
        self.__g.sichereDaten()
        alleDaten=self.__cont.gibDatenMit(self.zeichenflaeche) #einschl. Farbe usw
        try:
            f=open(dateiname,'w')
            text='Graph: '+self.__graphenVariable.get()+'\n\nKnoten:\n'
            for daten in alleDaten:
                if daten[0]=='Knoten':
                    text+=self.KnotenAufbereiten(daten[1])+'\n'
            text+='\nKanten:\n'
            for daten in alleDaten:
                if daten[0]=='Kante':
                    text+=self.KanteAufbereiten(daten[1])+'\n'
            f.write(text)
            f.close()
        except IOError as e: MeldungDialog(self,'Info', 'Fehler:'+str(e))

    def KnotenAufbereiten(self, daten):
        ausgabe=daten[0]+' '+ str((daten[1],daten[2]))
        if daten[3]!='': ausgabe+=' '+daten[3]
        return ausgabe

    def KanteAufbereiten(self,daten):
        ausgabe=daten[0]
        if daten[6]==LAST: ausgabe+='->'
        elif daten[6]==FIRST: ausgabe+='<-'
        else: ausgabe+='--'
        ausgabe+=daten[1]
        ausgabe+=' '+daten[5]
        if daten[3] in ('extern','Abstand'): ausgabe+=' Beschriftung: '+daten[2]
        return ausgabe
        
    def onBild(self):
        verzeichnis = 'Bilder'
        if self.__aktuellesVerzeichnis!='.': verzeichnis = self.__aktuellesVerzeichnis
        dateiname=self.__graphenVariable.get()+".ps"
        dateiname=fileDialog.asksaveasfilename(parent=self,
                                                       initialfile=dateiname,
                                                       defaultextension='ps',
                                                       initialdir=verzeichnis,
                                                       title="Graphenbild speichern")
        if dateiname!=():
            self.zeichenflaeche.postscript(file=dateiname)
        
    #### Mausereignisse  ----------------------------------------------
    def links_Mausklick(self, event):
        '''Klicks allgemein in die linke obere Ecke des Elements'''
        self.__click_position = (event.x,event.y)
        zf = self.zeichenflaeche
        ID = zf.find_closest(event.x, event.y)
        if ID==(): return # keine Elemente vorhanden
        if CanvasElement.istFigurID(ID[0]): # keine Klicks auf Texte
            self.__click_ID = ID[0]
            tag=zf.gettags(self.__click_ID)[0]
            element=CanvasElement.objektZuTag(tag)
            if element.__class__==KnotenElement:
                self.__ausgewaehlt=tag

    def links_Doppelklick(self, event):
        '''Bogenorientierung (-> Kante korrigieren) oder Knoten faerben'''
        self.__click_position = (event.x,event.y)
        zf = self.zeichenflaeche
        ID = zf.find_closest(event.x, event.y)
        if ID==(): return # keine Elemente vorhanden
        if CanvasElement.istFigurID(ID[0]): # keine Klicks auf Texte
            self.__click_ID = ID[0]
            tag=zf.gettags(self.__click_ID)[0]
            element=CanvasElement.objektZuTag(tag)
            if element.__class__==KantenElement:
                self.__cont.aendereBogenOrientierung(zf,tag)
            elif element.__class__==KnotenElement:
                self.onKnotenFaerben(tag)
            self.__geaendert = True

    def rechts_Mausklick(self, event):
        '''ermoeglicht das Bearbeiten von Knoten und Kanten'''
        zf = self.zeichenflaeche
        ID = zf.find_closest(event.x, event.y)
        if ID==(): return # keine Elemente vorhanden
        if CanvasElement.istFigurID(ID[0]): # keine Klicks auf Texte
            tag=zf.gettags(ID[0])[0]
            element=CanvasElement.objektZuTag(tag)
            if element.__class__==KantenElement:
                self.onKanteBeschriften(tag)
            else:
                self.onKnotenNamen(tag)
            self.__geaendert = True
            
    def links_loslassen(self, event):
        zf = self.zeichenflaeche
        if self.__click_ID!=None:
            ## erster Abschnitt fuer das Zeichnen einer Kante mit der Maus
            ID = zf.find_closest(event.x, event.y)
            if ID==(): return # keine Elemente vorhanden
            if self.__neueKante:
                if CanvasElement.istFigurID(ID[0]): # keine Klicks auf Texte
                    #self.__release_IDs = (self.__click_ID, ID[0])
                    von=zf.gettags(self.__click_ID)[0]
                    auf=zf.gettags(ID[0])[0]
                    self.__cont.neueKante(self.zeichenflaeche, von, auf)
                    self.__geaendert = True
            else:  # verwendet das tag des ausgewaehlten Objektes
                knoten=self.__g.gibKnotenZuNamen(self.__ausgewaehlt)
                self.__geaendert = True
                if knoten!=None:
                    kantenTags=[self.__ausgewaehlt]
                    for ka in self.__g.gibAlleKanten():
                        von,auf=ka.gibVon(),ka.gibAuf()
                        if (von in kantenTags)or(auf in kantenTags):
                            CanvasElement.aktualisiereKante(zf,von,auf,art)
        self.__ausgewaehlt = None
        self.__click_ID = None
        self.__neueKante = False

    def bewegt(self, event):
        '''nur Knoten koennen bewegt werden'''
        if self.__neueKante: return
        if not self.__ausgewaehlt: return
        if self.__click_ID != None:
            element=CanvasElement.objektZuTag(self.__ausgewaehlt)
            if element.__class__!=KnotenElement: return
            umX,umY = event.x - self.__click_position[0],\
                      event.y - self.__click_position[1]
            self.__cont.verschiebeKnotenUm(self.zeichenflaeche,
                                           self.__ausgewaehlt,umX,umY)
            self.zeichenflaeche.move(self.__ausgewaehlt, umX, umY)
            self.__click_position = (event.x,event.y)
    
    #### ------------------------------------------------------------------------
    def knotenWaehlenDialog(self):
        knotenNamen=self.__g.gibAlleKnotenNamen()
        dialog=AuswahlDialog(self,u'Knoten wählen',knotenNamen, True)
        return dialog.result # bei cancel None
        
    def Meldung(self, text):
        MeldungDialog(self,'Info', text)

    def zeigeHilfeText1(self):
        TextAusgabeDialog(
            self,
            'Hilfe zur Modellentwicklung',
            'Modellentwicklung',
            ["Im Menü 'Neu':\n"+
             "-den Punkt 'Neuer Graph' wählen um den Namen festzulegen.\n"+
             "-den Punkt 'Knoten' wählen und den neuen Namen eingeben.\n"+
             " Achten Sie auf Eindeutigkeit der Namen.\n"+
             "-den Punkt 'mehrere Knoten' wählen für bis zu 26 Knoten auf einmal.\n"+
             " Symbol mit der Maus (linke Taste, linke obere Ecke) an die passende\n Position ziehen.\n"+
             "-den Punkt 'Kante' wählen und Ausgangsknoten und Zielknoten wählen.\n\n"+
             "Im den Menüs 'Bearbeiten' und 'Löschen':\n"+
             "-sollten die Punkte selbst erklärend sein.\n"+
             "-'alle Kanten beschriften' für eine gleichartige Beschriftung.\n"+
             "-'Richtung der Kante ändern' zum Ändern oder Löschen der Richtung.\n\n"
             ])
    def zeigeHilfeText2(self):
        TextAusgabeDialog(
            self,
            'Hilfe zur Modelldefinitionsdatei',
            'Modelldefinition',
            ["Muster:\n", "[('Knoten', ('A', (100, 200))), ..., ('Kante', ('A', 'B', '200km', 'extern', versatz=0.3)), ...]",
             "\n\nRechtzeitig sichern, da nach Programmfehlern \n    (sorry!)\n Das Sichern eventuell nicht mehr geht."])
    def zeigeHilfeText3(self):
        TextAusgabeDialog(
            self,
            u'Hilfe zur Bilddatei',
            u'Bilddatei',
            ['postscript-Datei [.ps]\n\n'+
             'kann mit anderer Vektorgrafik-Software konvertiert werden;\n'+
             'z.B. Inkscape, irfanview mit addons usw'])
    def zeigeHilfeText4(self):
        TextAusgabeDialog(
            self,
            'Hilfe zu Kurztasten',
            'Kurztasten',
            ['Strg-o     Datei öffnen',
             'Strg-s     Datei speichern',
             'Strg-p     Bild  speichern',
             'Alt-n       Neues Modell',
             'Strg-k     Neuer Knoten',
             'Strg-f     Knoten färben',
             'Alt-k       Neue  Kante',
             'Strg-b     Kante im Bogen',
             'Alt-m      Neue  Kante mit Maus',
             'Alt-f        Kante färben',
             'Alt-b       Beschriftung einer Kante ändern',
             'Alt-a       Beschriftung aller Kanten ändern'])
    def zeigeHilfeText5(self):
        TextAusgabeDialog(
            self,
            'Hilfe zu Mausaktionen',
            'Mausaktionen',
            ['Klick links       Objektauswählen',
            'Maus ziehen        Objekt ziehen ',
            'links loslassen    Ziehen beenden',
            'Klick rechts       Kante beschriften / Knotennamen ändern',
            'Doppelklick links  Orientierung eines Kantenbogens / Knoten färben'
             ])
    def zeigeHilfeText6(self):
        TextAusgabeDialog(
            self,
            'Hilfe zum Ändern der Modellfenstergröße',
            'Ändern der Modellfenstergröße',
            ['\nSichern und Beenden Sie das Projekt.\n',
            'Starten Sie es neu und geben Sie die neue Größe ein.'])
        
    #### Beispiel zeichnen
    def zeichne_Objekte(self):
        if not self.__cont.istLeer():
            MeldungDialog(self,u'Achtung !','Fenster ist nicht leer!\nFür Beispiel Programm neu starten!')
            return
        zf = self.zeichenflaeche

        self.__graphenVariable.set('Graph')

        self.__cont.neuerKnoten(zf,'A',(100,100))
        self.__cont.neuerKnoten(zf,'B',(200,250))
        self.__cont.neueKante(zf,'A', 'B')
        self.__cont.neuerKnoten(zf,'C',(250,30),"red")
        self.__cont.neueKante(zf,'A', 'C', '200km', 'extern', versatz=0.3)
        self.__cont.neuerKnoten(zf,'D',(300,300))
        self.__cont.neueKante(zf,'D', 'C', beschriftung='Name', versatz=0.1)
        self.__cont.neueKante(zf,'B', 'D', ' ', 'Abstand',farbe="blue")
        self.__g.sichereDaten()
        ##print(self.__g.gibDaten())


#### als Hauptfenster starten
if __name__=='__main__':
    root = Tk()
    groesseDialog = N_EingabenDialog(root,
                                     'Geben Sie die Groesse vor',
                                     [u'Breite',u'Höhe'],
                                     [700,800])
    if groesseDialog.result==None:
        zeichenflaechenBreite=700
        zeichenflaechenHoehe=800
    else:
        try:
            zeichenflaechenBreite=int(groesseDialog.result[0])
            zeichenflaechenHoehe=int(groesseDialog.result[1])
        except ValueError as e:
            zeichenflaechenBreite=700
            zeichenflaechenHoehe=800            
            
    fenster = GraphenApplication(master=root,
                                 zeichenflaechenBreite=zeichenflaechenBreite,
                                 zeichenflaechenHoehe=zeichenflaechenHoehe)
    fenster.master.title('Graph')
    fenster.mainloop()
    try:
        root.destroy()
    except Exception: pass
